﻿using System;
using System.Collections;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml;

namespace SmsApi
{

    public partial class SmsApiClass : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void btn_Click(object sender, EventArgs e)
        {
            SmsXmlRpcClass smsclass = new SmsXmlRpcClass();

            /*
             * index() : 기본 xml-rpc 통신 연결을 하기 위한 함수
             * string sms_id : SMS 호스팅 신청시 발급한 아이디
             * string api_key : sms.gabia.com 로그인뒤 환경설정에서 발급받은 api_key 값
            */
            //public void index(string sms_id, string api_key)
            smsclass.index("_SMS_ID_", "_API_KEY_");

            //등록된 발신번호 리스트 가져오기
            /*
             * getCallbackNum()        : 등록된 발신번호 리스트 가져올때 사용
             * smsclass.callback_Array : 등록된 발신번호 리스트 ( TYPE:ARRAY )
             * return                  : 통신 성공여부
            */
            string smsresult = smsclass.getCallbackNum();

            string[] result_all;
            string result_txt = "";
            if (smsresult == "0000")
            {
                result_all = smsclass.callback_Array;
                for (int i = 0; i < result_all.Length; i++)
                {
                    //Response.Write i;
                    result_txt += "전화번호: " + result_all[i] + "<br>";
                }
            }
            else
            {
                result_txt = "리스트 가져오기 실패";
            }

            lb6.Text = result_txt;

            //예약 취소
            /*
             * reserveCancel()       : 예약 취소시 사용
             * string ref_key        : 문자 발송시 사용했던 unique키 값
             * string sms_type       : 예약 문자 전송시 사용한 타입 sms or lms
             * string phonenum       : 수신자 번호 ( "01000000001,01000000002" 의 형태로 보내야 작동) //phonenum을 빈값으로 보낼시 ref_key값으로 보내진 모든 예약문자는 취소가 됩니다.
             * return                : 예약 취소의 결과값 ( 0000 을 제외한 나머지 값은 실패)
            */
            //public string reserveCancel(string ref_key, string send_type, string phonenum="")
            /*string phonenum = "01000000001, 01000000002";
            smsclass.reserveCancel("_UNIQUE_KEY_", "_SMS_TYPE_", phonenum);
            if ( smsclass.getCode == "0000")
            {
                lb5.Text = "예약이 취소되었습니다.";
            }
            else
            {
                lb5.Text = smsclass.getCode;
            }*/
            //SMS 현재 건수
            // return : 현재 남아있는 SMS 건수
            //lb1.Text = smsclass.getSmsCount();

            //sms 전송
            /*
             * sms_send()       : 단문(90byte) 전송시 사용
             * string phonenum  : 수신자 번호 (핸드폰의 경우 010-1234-5678 or 01012345678 값으로 전송)
             * string callback  : 발신자 번호 (핸드폰의 경우 010-1234-5678 or 01012345678 값으로 전송)
             * string msg       : 최대 90byte 까지 전송 가능, 90byte가 넘어서 전송이 되는경우 90byte 뒤의 글은 잘려서 전송
             * string ref_key   : 실제 문자의 전송 결과 값을 가져올수 있는 값으로 get_status_by_ref 의 parameter값으로 쓰임
             * string date      : 문자 예약으로 발송시 사용 ("2013-01-02 09:05:00" 형태로 보내야 정상 작동)
             * 
             * return           : 발송 요청의 결과값 ( 0000 을 제외한 나머지 값은 실패)
            */
            //public String sms_send(string phonenum, string callback, string msg, string ref_key = "", string date = "0")

            //smsclass.sms_send("_PHONENUM_", "_CALLBACK_", "_MESSAGE_", "_REF_KEY_", "_RESERVE_DATE_");

            //lms 전송
            /*
             * lms_send()       : 장문 전송시 사용하는 함수
             * string phonenum  : 수신자 번호 (핸드폰의 경우 010-1234-5678 or 01012345678 값으로 전송)
             * string callback  : 발신자 번호 (핸드폰의 경우 010-1234-5678 or 01012345678 값으로 전송)
             * string subject   : 문자의 제목으로 40byte 까지 전송 가능
             * string msg       : 최대 2000byte 까지 전송 가능, 넘어가는 경우 2000byte 뒤의 글은 짤려 나감
             * string ref_key   : 실제 문자의 전송 결과 값을 가져올수 있는 값으로 get_status_by_ref 의 parameter값으로 쓰임
             * string date      : 문자 예약으로 발송시 사용 ("2013-01-02 09:05:00" 형태로 보내야 정상 작동)
             * 
             * return           : 발송 요청의 결과값 ( 0000 을 제외한 나머지 값은 실패)
            */
            //public String lms_send(string phonenum, string callback, string subject = "", string msg="", string ref_key = "", string date = "0")

            //smsclass.lms_send("_PHONENUM_", "_CALLBACK_", "_SUBJECT_", "_MESSAGE_", "_REF_KEY_", "_RESERVE_DATE_");

            //mms 전송
            /*
             * mms_send()           : 장문 이미지 전송시 사용
             * string phonenum      : 수신자 번호 (핸드폰의 경우 010-1234-5678 or 01012345678 값으로 전송)
             * string callback      : 발신자 번호 (핸드폰의 경우 010-1234-5678 or 01012345678 값으로 전송)
             * string[] file_path   : 전송할 이미지 경로 최대 3개 이미지 전송가능 (C:\\test.jpg)
             * string msg           : 최대 2000byte 까지 전송 가능, 2000byte가 넘어서 전송이 되는경우 2000byte 뒤의 글은 잘려서 전송
             * string subject       : 문자의 제목으로 40byte 까지 전송 가능
             * string ref_key       : 실제 문자의 전송 결과 값을 가져올수 있는 값으로 get_status_by_ref 의 parameter값으로 쓰임
             * string date          : 문자 예약으로 발송시 사용 ("2013-01-02 09:05:00" 형태로 보내야 정상 작동)
             * 
             * return           : 발송 요청의 결과값 ( 0000 을 제외한 나머지 값은 실패)
            */
            // public String mms_send(string phonenum, string callback, string[] file_path, string msg, string subject, string ref_key = "", string date = "0")

            // String[] image_path = new String[3];
            // Array.Clear(image_path, 0, image_path.Length);
            // image_path[0] = "C:\\test.jpg";
            // image_path[1] = "C:\\test.jpg";
            // image_path[2] = "C:\\test.jpg";

            // smsclass.mms_send("_PHONENUM_", "_CALLBACK_", image_path, "_MESSAGE_", "_SUBJECT_", "_REF_KEY_", "_RESERVE_DATE_");

            //multi_sms 전송
            /*
             * 한번에 여러명에게 문자 메시지 전송
             * multi_sms_send()     : 단문(90byte) 전송시 사용
             * string[] phonenum    : 수신자 번호 (핸드폰의 경우 010-1234-5678 or 01012345678 값으로 전송)
             * string callback      : 발신자 번호 (핸드폰의 경우 010-1234-5678 or 01012345678 값으로 전송)
             * string msg           : 최대 90byte 까지 전송 가능, 90byte가 넘어서 전송이 되는경우 90byte 뒤의 글은 잘려서 전송
             * string ref_key       : 실제 문자의 전송 결과 값을 가져올수 있는 값으로 get_status_by_ref 의 parameter값으로 쓰임
             * string date          : 문자 예약으로 발송시 사용 ("2013-01-02 09:05:00" 형태로 보내야 정상 작동)
             * 
             * return               : 발송 요청의 결과값 ( 0000 을 제외한 나머지 값은 실패)
             */
            //public String multi_sms_send(string[] phonenum, string callback, string msg, string ref_key = "", string date = "0")

            //string[] phonenum = new string[5] { "01000000001", "01000000002", "01000000003", "01000000004", "01000000005" };
            //smsclass.multi_sms_send(phonenum, "_CALLBACK_", "_MESSAGE_", "_REF_KEY_", "_RESERVE_DATE");


            //multi_lms 전송
            /*
             * lms_send()           : 장문 전송시 사용하는 함수
             * string[] phonenum    : 수신자 번호 (핸드폰의 경우 010-1234-5678 or 01012345678 값으로 전송)
             * string callback      : 발신자 번호 (핸드폰의 경우 010-1234-5678 or 01012345678 값으로 전송)
             * string subject       : 문자의 제목으로 40byte 까지 전송 가능
             * string msg           : 최대 2000byte 까지 전송 가능, 넘어가는 경우 2000byte 뒤의 글은 짤려 나감
             * string ref_key       : 실제 문자의 전송 결과 값을 가져올수 있는 값으로 get_status_by_ref 의 parameter값으로 쓰임
             * string date          : 문자 예약으로 발송시 사용 ("2013-01-02 09:05:00" 형태로 보내야 정상 작동)
             * 
             * return               : 발송 요청의 결과값 ( 0000 을 제외한 나머지 값은 실패)
            */
            //public String multi_lms_send(string[] phonenum, string callback, string subject = "", string msg = "", string ref_key = "", string date = "0")

            //smsclass.multi_lms_send(phonenum, "01000000002", "tesateasdfasd", "adsfadsfadfsfaaadfs", "","");
            //if (smsclass.getCode == "0000")
            //{
            /*
             * 발송결과후 얻을수 있는 값
             * sms_send, lms_send : before_cnt, after_cnt
             * multi_sms_send, multi_lms_send : before_cnt, after_cnt, success_cnt, fail_list
             * 
             * before_cnt  : 발송전 건수
             * after_cnt   : 발송후 건수
             * success_cnt : 발송에 성공한 건수
             * fail_list   : 발송에 실패한 리스트
             */
            //lb2.Text = smsclass.before_cnt;
            //lb3.Text = smsclass.after_cnt;
            /*
             * 한건 발송했을때 의한 실제 발송 결과값 확인
             * get_status_by_ref() : 문자 발송의 실제 결과값을 확인하는 함수
             * string ref_key : 문자 발송시 사용했던 ref_key 값을 통해 문자발송여부 확인
             * 
             * return : 실제 발송의 결과 상태 메시지 (성공, 실패, 시간초과, ING(발송중), 기타)
            */
            //public String get_status_by_ref(string ref_key)
            //smsclass.get_status_by_ref("adsfadsfadfsfaaadfs");


            /*
             * 여러건 발송했을때 실제 발송 결과값들 확인
             * 
             * get_Status_By_Ref_all(): 문자 발송의 실제 결과값들을 확인하는 함수
             * string ref_key : 문자 발송시 사용했던 ref_key 값을 통해 문자발송여부 확인
             * 
             * 얻을수 있는 값
             * public string[,] MessageOfResultMesgArray : 문자 전송 성공여부 & 수신자 번호
             */
            //public string get_Status_By_Ref_all(string ref_key)
            //string smsresult = smsclass.get_Status_By_Ref_all("test");
            //string[,] result_all;

            //if (smsresult == "0000")
            //{
            //    result_all = smsclass.MessageOfResultMesgArray;
            //}

            //lb4.Text = smsclass.MesageofResultMESG;
            //}

        }
    }
}