﻿using System;
using System.Security;
using System.Security.Cryptography;
using System.Text;
using System.IO;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CookComputing.XmlRpc;
using System.Xml;
using System.Collections.Generic;

//SMS 발송 정보
public class SmsXmlConfig
{
    public string domain = "sms.gabia.com";
    public string sms_id = "";
    public string api_key = "";

    public string result_XML = "";
    public string result_DOM = "";
    public string result_CODE = "";
    public string result_MSG = "";
    public string result = "";

    public int before_cnt = 0;
    public int after_cnt = 0;

    public string md5_access_token = "";
    public string Result_OK = "0000";
    public int CALL_ERROR = -1;

    //xml-rpc 통신 인증용 token 값 추출
    public void SmsXmlRpcClass_init(string sms_id, string api_key)
    {
        this.sms_id = sms_id;
        this.api_key = api_key;

        string nonce = this.get_nonce();
        MD5 md5Hasher = MD5.Create();
        byte[] data = md5Hasher.ComputeHash(Encoding.Default.GetBytes(nonce.Insert(nonce.Length, this.api_key)));
        string strResult = BitConverter.ToString(data);
        strResult = strResult.Replace("-", "");
        // string token_tmp = FormsAuthentication.HashPasswordForStoringInConfigFile(, "MD5");
        this.md5_access_token = nonce.Insert(nonce.Length, strResult);
    }

    public string get_nonce()
    {
        string random_key = "";
        System.Random random = new System.Random();
        for (int i = 0; i < 8; i++)
        {
            random_key += string.Format("{0:X}", random.Next(0, 15));
        }

        return random_key;
    }
}


//SMS API 연동 정보
[XmlRpcUrl("http://sms.gabia.com/api")]
public interface iSmsMethod : IXmlRpcProxy
{
    [XmlRpcMethod("gabiasms")]
    string CallMethod(String strXML);
}

struct SmsParam
{
    public string key;
    public string value;

    public SmsParam(string key, string value)
    {
        this.key = key;
        this.value = value;
    }
}

struct SmsItem
{
    public string key;
    public string value;

    public SmsItem(string key, string value)
    {
        this.key = key;
        this.value = value;
    }
}


//결과값 리턴
public class SmsResponse
{
    public string code;
    public string msg;
    public string result;
    public ArrayList xmlPHONEresult;

    private XmlDocument doc;
    private XmlDocument docResult;

    public SmsResponse(string xml_string)
    {
        doc = new XmlDocument();
        doc.LoadXml(xml_string);
    }

    public string getNodeText(string xpath)
    {
        XmlNode node = this.doc.SelectSingleNode(xpath);
        return node.InnerText;
    }

    public string getCode()
    {
        return this.getNodeText("response/code");
    }

    public string getMesg()
    {
        return this.getNodeText("response/mesg");
    }

    public string getResult()
    {
        string result_base64 = this.getNodeText("response/result");
        return this.base64_decode(result_base64);
    }

    public string base64_decode(string str)
    {
        byte[] data = System.Convert.FromBase64String(str);
        string return_value = System.Text.Encoding.UTF8.GetString(data);
        return return_value;
    }

    public string getNodeTextofResult(string xpath)
    {
        XmlNode nodeofResult = this.docResult.SelectSingleNode(xpath);
        if (nodeofResult == null)
            return "NONE";
        else
            return nodeofResult.InnerText;
    }

    public string MesageofResultMESG(string getResult)
    {
        docResult = new XmlDocument();
        docResult.LoadXml(getResult);
        string result_base64 = this.getNodeTextofResult("root/smsResult/entries/entry/MESG");
        return result_base64;
    }

    public string MesageofResultCODE(string getResult)
    {
        docResult = new XmlDocument();
        docResult.LoadXml(getResult);
        string result_base64 = this.getNodeTextofResult("root/smsResult/entries/entry/CODE");
        return result_base64;
    }

    public string[,] MesageofResultMESGS_All(string getResult)
    {
        docResult = new XmlDocument();
        docResult.LoadXml(getResult);
        XmlNodeList xnList = docResult.SelectNodes("root/smsResult/entries/entry");

        string[,] rslt_value = new string[xnList.Count, 2];
        int i = 0;
        foreach (XmlNode xn in xnList)
        {
            rslt_value[i, 0] = xn["MESG"].InnerText;
            rslt_value[i, 1] = xn["PHONENUM"].InnerText;
            i++;
        }
        return rslt_value;
    }

    public string[] callback_list_parse(string getResult)
    {
        docResult = new XmlDocument();
        docResult.LoadXml(getResult);
        XmlNodeList xnList = docResult.SelectNodes("root/smsResult/entries/entry");

        string[] rslt_value = new string[xnList.Count];
        int i = 0;
        foreach (XmlNode xn in xnList)
        {
            rslt_value[i] = xn["callback"].InnerText;
            i++;
        }
        return rslt_value;
    }
}

//SMS API 연동할 함수 호출
public class SmsXmlRpcClass
{
    public SmsXmlConfig smsconfig = new SmsXmlConfig();
    public string getResult;
    public string getMESG;
    public string getCode;
    public string MesageofResultMESG;
    public string MesageofResultCODE;
    public string before_cnt;
    public string after_cnt;
    public string success_cnt;
    public string fail_list;
    public string ref_getResult;
    public string ref_getMESG;
    public string ref_getCode;

    public string[,] MessageOfResultMesgArray;
    public string[] callback_Array;

    public void index(string sms_id, string api_key)
    {
        smsconfig.SmsXmlRpcClass_init(sms_id, api_key);
    }
    //SMS 남은 건수 확인
    public String getSmsCount()
    {
        SmsApiClient sms_api_client = new SmsApiClient(smsconfig.sms_id, smsconfig.md5_access_token);
        SmsResponse result;
        ArrayList xml_params = new ArrayList();

        result = sms_api_client.call("SMS.getSmscount", xml_params);
        return result.getResult();
    }

    //SMS 실제 발송의 결과값 확인
    public String get_status_by_ref(string ref_key)
    {
        SmsApiClient sms_api_client = new SmsApiClient(smsconfig.sms_id, smsconfig.md5_access_token);
        SmsResponse result;
        ArrayList xml_params = new ArrayList();
        xml_params.Add(new SmsParam("ref_key", ref_key));

        result = sms_api_client.call("SMS.getStatusByRef", xml_params);
        this.ref_getMESG = result.getMesg();
        this.ref_getCode = result.getCode();
        this.ref_getResult = result.getResult();
        this.MesageofResultMESG = result.MesageofResultMESG(this.ref_getResult);
        this.MesageofResultCODE = result.MesageofResultCODE(this.ref_getResult);

        return this.MesageofResultCODE;
    }

    //등록된 발신번호 리스튼
    public string getCallbackNum()
    {
        SmsApiClient sms_api_client = new SmsApiClient(smsconfig.sms_id, smsconfig.md5_access_token);
        SmsResponse result;
        ArrayList xml_params = new ArrayList();

        result = sms_api_client.call("SMS.getCallbackNum", xml_params);

        this.ref_getMESG = result.getMesg();
        this.ref_getCode = result.getCode();
        this.ref_getResult = result.getResult();
        this.MesageofResultMESG = result.MesageofResultMESG(this.ref_getResult);
        this.MesageofResultCODE = result.MesageofResultCODE(this.ref_getResult);

        this.callback_Array = result.callback_list_parse(this.ref_getResult);

        return this.ref_getCode;
    }

    //SMS 발송
    public String sms_send(string phonenum, string callback, string msg, string ref_key = "", string date = "0")
    {
        if (phonenum == "" || callback == "" || msg == "")
        {
            return "false";
        }
        SmsApiClient sms_api_client = new SmsApiClient(smsconfig.sms_id, smsconfig.md5_access_token);
        SmsResponse result;
        ArrayList xml_params = new ArrayList();
        xml_params.Add(new SmsParam("send_type", "sms"));
        xml_params.Add(new SmsParam("ref_key", ref_key));
        xml_params.Add(new SmsParam("message", msg));
        xml_params.Add(new SmsParam("callback", callback));
        xml_params.Add(new SmsParam("phone", phonenum));
        xml_params.Add(new SmsParam("reserve", date));

        result = sms_api_client.call("SMS.send", xml_params);

        this.getMESG = result.getMesg();
        this.getCode = result.getCode();
        this.getResult = result.getResult();
        setSendResult();
        return this.getCode;
    }

    public String lms_send(string phonenum, string callback, string subject = "", string msg = "", string ref_key = "", string date = "0")
    {
        if (phonenum == "" || callback == "" || msg == "")
        {
            return "false";
        }
        SmsApiClient sms_api_client = new SmsApiClient(smsconfig.sms_id, smsconfig.md5_access_token);
        SmsResponse result;
        ArrayList xml_params = new ArrayList();
        xml_params.Add(new SmsParam("send_type", "lms"));
        xml_params.Add(new SmsParam("ref_key", ref_key));
        xml_params.Add(new SmsParam("subject", subject));
        xml_params.Add(new SmsParam("message", msg));
        xml_params.Add(new SmsParam("callback", callback));
        xml_params.Add(new SmsParam("phone", phonenum));
        xml_params.Add(new SmsParam("reserve", date));

        result = sms_api_client.call("SMS.send", xml_params);

        this.getMESG = result.getMesg();
        this.getCode = result.getCode();
        this.getResult = result.getResult();

        setSendResult();
        return this.getCode;
    }

    public String mms_send(string phonenum, string callback, string[] file_path, string msg, string subject, string ref_key = "", string date = "0")
    {
        if (phonenum == "" || callback == "" || msg == "")
        {
            return "false";
        }
        SmsApiClient sms_api_client = new SmsApiClient(smsconfig.sms_id, smsconfig.md5_access_token);
        SmsResponse result;
        ArrayList xml_params = new ArrayList();
        xml_params.Add(new SmsParam("send_type", "mms"));
        xml_params.Add(new SmsParam("ref_key", ref_key));
        xml_params.Add(new SmsParam("subject", subject));
        xml_params.Add(new SmsParam("message", msg));
        xml_params.Add(new SmsParam("callback", callback));
        xml_params.Add(new SmsParam("phone", phonenum));
        xml_params.Add(new SmsParam("reserve", date));

        int image_count = 0;

        // 파일처리
        for (int i = 0; i < file_path.Length; i++)
        {
            if (file_path[i] == "" && i == 0)
                return "false";
            else if (file_path[i] == "")
                continue;

            using (FileStream fs = File.Open(file_path[i], FileMode.Open))
            {
                byte[] image_item = new byte[fs.Length];
                Array.Clear(image_item, 0, image_item.Length);
                int numByteRead = (int)fs.Length;

                fs.Read(image_item, 0, numByteRead);

                String image_code = Convert.ToBase64String(image_item);

                xml_params.Add(new SmsParam(Convert.ToString(i), image_code));
                image_count++;
            }
        }
        xml_params.Add(new SmsParam("file_cnt", Convert.ToString(image_count)));

        result = sms_api_client.call("SMS.send", xml_params);

        this.getMESG = result.getMesg();
        this.getCode = result.getCode();
        this.getResult = result.getResult();
        setSendResult();
        return this.getCode;
    }

    public void setSendResult()
    {
        XmlDocument xmlparse = new XmlDocument();
        if (this.getResult != null)
        {
            xmlparse.LoadXml(this.getResult);
            XmlElement KeyList = xmlparse.DocumentElement;

            XmlNodeList xnList = xmlparse.SelectNodes("/root");

            foreach (XmlNode node1 in xnList)
            {
                this.before_cnt = node1["BEFORE_SMS_QTY"].InnerText;
                this.after_cnt = node1["AFTER_SMS_QTY"].InnerText;
            }
        }
    }
    public String multi_sms_send(string[] phonenum, string callback, string msg, string ref_key = "", string date = "0")
    {
        String multi_phone_num = make_string_phonenum(phonenum);
        if (multi_phone_num == "" || callback == "" || msg == "")
        {
            return "false";
        }
        SmsApiClient sms_api_client = new SmsApiClient(smsconfig.sms_id, smsconfig.md5_access_token);
        SmsResponse result;
        ArrayList xml_params = new ArrayList();
        xml_params.Add(new SmsParam("send_type", "sms"));
        xml_params.Add(new SmsParam("ref_key", ref_key));
        xml_params.Add(new SmsParam("message", msg));
        xml_params.Add(new SmsParam("callback", callback));
        xml_params.Add(new SmsParam("phone", multi_phone_num));
        xml_params.Add(new SmsParam("reserve", date));

        result = sms_api_client.call("SMS.multi_send", xml_params);

        this.getMESG = result.getMesg();
        this.getCode = result.getCode();
        this.getResult = result.getResult();
        if (this.getCode == "0000")
            setMultiSendResult();

        setMultiSendResult();

        return this.getCode;
    }

    public String multi_lms_send(string[] phonenum, string callback, string subject = "", string msg = "", string ref_key = "", string date = "0")
    {
        String multi_phone_num = make_string_phonenum(phonenum);
        if (multi_phone_num == "" || callback == "" || msg == "")
        {
            return "false";
        }
        SmsApiClient sms_api_client = new SmsApiClient(smsconfig.sms_id, smsconfig.md5_access_token);
        SmsResponse result;
        ArrayList xml_params = new ArrayList();
        xml_params.Add(new SmsParam("send_type", "lms"));
        xml_params.Add(new SmsParam("ref_key", ref_key));
        xml_params.Add(new SmsParam("subject", subject));
        xml_params.Add(new SmsParam("message", msg));
        xml_params.Add(new SmsParam("callback", callback));
        xml_params.Add(new SmsParam("phone", multi_phone_num));
        xml_params.Add(new SmsParam("reserve", date));

        result = sms_api_client.call("SMS.multi_send", xml_params);

        this.getMESG = result.getMesg();
        this.getCode = result.getCode();
        this.getResult = result.getResult();
        if (this.getCode == "0000")
            setMultiSendResult();

        return this.getCode;
    }

    public String make_string_phonenum(string[] phonenum)
    {
        StringBuilder builder = new StringBuilder();
        foreach (string value in phonenum)
        {
            builder.Append(value);
            builder.Append(",");
        }
        string multi_phonenum = builder.ToString();
        return multi_phonenum;
    }

    public void setMultiSendResult()
    {
        if (this.getResult != null)
        {
            XmlDocument xmlparse = new XmlDocument();

            xmlparse.LoadXml(this.getResult);
            XmlElement KeyList = xmlparse.DocumentElement;

            XmlNodeList xnList = xmlparse.SelectNodes("/root");

            foreach (XmlNode node1 in xnList)
            {
                this.before_cnt = node1["BEFORE_SMS_QTY"].InnerText;
                this.after_cnt = node1["AFTER_SMS_QTY"].InnerText;
                this.success_cnt = node1["SUCCESS_CNT"].InnerText;
                this.fail_list = node1["FAIL_LIST"].InnerText;
            }
        }
    }

    public string get_Status_By_Ref_all(string ref_key)
    {
        SmsApiClient sms_api_client = new SmsApiClient(smsconfig.sms_id, smsconfig.md5_access_token);
        SmsResponse result;
        ArrayList xml_params = new ArrayList();
        xml_params.Add(new SmsParam("ref_key", ref_key));

        result = sms_api_client.call("SMS.getStatusByRef_all", xml_params);

        this.ref_getMESG = result.getMesg();
        this.ref_getCode = result.getCode();
        this.ref_getResult = result.getResult();
        this.MesageofResultMESG = result.MesageofResultMESG(this.ref_getResult);
        this.MesageofResultCODE = result.MesageofResultCODE(this.ref_getResult);

        this.MessageOfResultMesgArray = result.MesageofResultMESGS_All(this.ref_getResult);

        return this.ref_getCode;
    }

    public string reserveCancel(string ref_key, string send_type, string phonenum = "")
    {
        SmsApiClient sms_api_client = new SmsApiClient(smsconfig.sms_id, smsconfig.md5_access_token);
        SmsResponse result;
        ArrayList xml_params = new ArrayList();
        xml_params.Add(new SmsParam("send_type", send_type));
        xml_params.Add(new SmsParam("ref_key", ref_key));
        xml_params.Add(new SmsParam("phonenum", phonenum));

        result = sms_api_client.call("SMS.reservationCancel", xml_params);

        this.getMESG = result.getMesg();
        this.getCode = result.getCode();
        this.getResult = result.getResult();

        return this.ref_getCode;
    }
}

//SMS API 요청할때 필요한 값
public class SmsApiClient
{
    public string requestXML;
    public string sms_id;
    public string md5_token;
    public HttpResponse res;

    public static string xml_format =
        "<request>\n<sms-id>{0}</sms-id>\n<access-token>{1}</access-token>\n<response-format>xml</response-format>\n<method>{2}</method>\n<params>{3}</params>\n</request>";

    public SmsApiClient(string sms_id, string md5_token)
    {
        this.sms_id = sms_id;
        this.md5_token = md5_token;
    }



    private string makeRequestXML(string methodName, string xml_params)
    {
        string result;

        result = String.Format(SmsApiClient.xml_format, this.sms_id, this.md5_token, methodName, xml_params);

        return result;
    }

    private string CallFunc(string request_xml)
    {
        iSmsMethod proxy = (iSmsMethod)XmlRpcProxyGen.Create(typeof(iSmsMethod));

        string response = proxy.CallMethod(request_xml);

        return response;
    }

    public SmsResponse call(string methodName)
    {
        return this.call(methodName, null);
    }

    public SmsResponse call(string methodName, ArrayList xml_params)
    {
        SmsParam param;
        string xmlparam = "";

        if (xml_params != null)
        {
            for (int j = 0; j < xml_params.Count; j++)
            {
                param = (SmsParam)xml_params[j];

                if(param.key == "0")
                {
                    xmlparam = String.Format("{0}<file_bin_{1} xmlns:dt='urn:schemas-microsoft-com:datatypes' dt:dt='bin.base64'>{2}</file_bin_{1}>" + System.Environment.NewLine, xmlparam, param.key.Trim(), param.value.Trim());
                }
                else if (param.key == "1")
                {
                    xmlparam = String.Format("{0}<file_bin_{1} xmlns:dt='urn:schemas-microsoft-com:datatypes' dt:dt='bin.base64'>{2}</file_bin_{1}>" + System.Environment.NewLine, xmlparam, param.key.Trim(), param.value.Trim());
                }
                else if (param.key == "2")
                {
                    xmlparam = String.Format("{0}<file_bin_{1} xmlns:dt='urn:schemas-microsoft-com:datatypes' dt:dt='bin.base64'>{2}</file_bin_{1}>" + System.Environment.NewLine, xmlparam, param.key.Trim(), param.value.Trim());
                }
                else
                {
                    xmlparam = String.Format("{0}<{1}>{2}</{1}>" + System.Environment.NewLine, xmlparam, param.key.Trim(), param.value.Trim());
                }
            }
        }

        string xml = this.makeRequestXML(methodName, xmlparam);
        string result_xml = this.CallFunc(xml);

        SmsResponse ret = new SmsResponse(result_xml);

        return ret;
    }

}